// AUCTION

// Seller.m				
  
#import "Bank.h"
#import <simtools.h>


@implementation Bank 

+createBegin: (id)  aZone {
  Bank * obj;
  obj = [super createBegin: aZone];
  return obj;
}

-createEnd {
  // [ObjectLoader load: self fromFileNamed: "bank.setup"];
  return [super createEnd];
}

-initialize {
  PDDist = [NormalDist createWithDefaults: [self getZone]];
  return self;
}


-setID: (unsigned short) idnum {
 bankID = idnum;
 return self;
}

-(unsigned short) getID {
  return bankID;
}

-setRiskAv: (double) R {
  riskAv=R;
  return self;
}

-(double) getRiskAv {
  return riskAv;
}

-setDivFac: (double) xi {
  divFac=xi;
  return self;
}

-(double) getDivFac {
  return divFac;
}

-setBasApp: (unsigned short) A {
  basApp=A;
  return self;
}

-(unsigned short) getBasApp {
  return basApp;
}

-setTargCapRat: (double) t {
  targCapRat=t;
  return self;
}

-(double) getTargCapRat {
  return targCapRat;
}

-setMargin: (double) m{
  margin=m;
  return self;
}

-(double) getMargin {
  return margin;
}

-setCostInc: (double) CI {
  costInc=CI;
  return self;
}

-(double) getCostInc {
  return costInc;
}

-setCostRat: (double) CR {
  costRat=CR;
  return self;
}

-(double) getCostRat {
  return costRat;
}

-setMemStrength: (double) MS {
  memStrength=MS;
  return self;
}

-(double) getMemStrength {
  return memStrength;
}

-setTotExp: (double) TE {
  totExp=TE;
  return self;
}

-(double) getTotExp {
  return totExp;
}

-setTotRWA: (double) TRWA {
  totRWA=TRWA;
  return self;
}

-(double) getTotRWA {
  return totRWA;
}

-setTotProf: (double) TP {
  totProf=TP;
  return self;
}

-(double) getTotProf {
  return totProf;
}

-setCapRat: (double) CR {
  capRat= CR;
  return self;
}

-(double) getCapRat {
  return capRat;
}

-setCapital: (double) C {
  capital=C;
  return self;
}

-(double) getCapital {
  return capital;
}

-setIntCap: (double) IC {
  intCap=IC;
  return self;
}

-(double) getIntCap {
  return intCap;
}

-setGin: (double) G {
  Gini=G;
  return self;
}

-(double) getGin {
  return Gini;
}

-setIntRat: (double) IR {
  intRat=IR;
  return self;
}

-(double) getIntRat {
  return intRat;
}

-setPDMean: (double) PD {
  PDMean=PD;
  return self;
}

-(double) getPDMean {
  return PDMean;
}

-setPDSigma: (double) PDS{
  PDSigma=PDS;
  return self;
}

-(double) getPDSigma {
  return PDSigma;
}

-updateRWA {
    totRWA=totExp*0.5*(1-Gini*basApp);
  return self;
}

-updateCapRat {
  capRat=capital/totRWA;
  return self;
}

-updateDefaults {
  double dropOutFactor=0;
  while (dropOutFactor<=0)
    dropOutFactor= [PDDist getSampleWithMean: PDMean withVariance: PDSigma];
  [self setTotExp: totExp*(1-dropOutFactor*(1-Gini*basApp))];
  // [self setCapital: capital-totExp*dropOutFactor];
  return self;
}


-updateProfits{
  intRat= (PDMean*(1-Gini*basApp)+intCap)*(1+margin);
  profit=totExp*(intRat-intCap);
  capital=capital+profit*(1-costInc)-costRat*basApp;
  printf("Bank %d \t Exp %f \t Prof %f \t Cap%f\n",bankID, [self getTotExp], profit, capital);
  return self;
}

-drawSelfOn: (id<Raster>)r
{
  // [r drawPointX: capital/5000 Y: totExp/5000 Color: 1];
  printf("B1\n");
  [r drawPointX: 50 Y: 50 Color: 2];
  printf("B2\n");
  return self;
}

-setWorld: (id<Grid2d>)w {
  world =w;
  return self;
}

-setCustSize: (double) CS {
  custSize=CS;
  return self;
}

-setSelMarker: (unsigned short)x {
  selMarker= x;
  return self;
}

-(unsigned short) getSelMarker {
  return selMarker;
}



@end

  


