// BANK SIMULATOR
// ModelSwarm.h					

#import "Bank.h"

#import <objectbase.h>
#import <objectbase/Swarm.h>
#import <space.h> //Grid2d
//#import <space/Diffuse2d.h>
#import <random.h>


@interface ModelSwarm: Swarm { 
  id <Grid2d> world;

  int randomSeed;
  int numBanks;
  int reportingBankID;

  int capMean;
  int capSigma;
  double targCapMean;
  double targCapSigma;
  double riskAvMean;
  double riskAvSigma;
  double divFacMean;
  double divFacSigma;
  double marginMean;
  double marginSigma;
  double costIncMean;
  double costIncSigma;
  double costRatMean;
  double costRatSigma;
  double intRatMean;
  double intRatSigma;

  double memStrengthMean;
  double memStrengthSigma;
  double expoMean;
  double expoSigma;
  double ginMean;
  double ginSigma;
  double PDMean;
  double PDSigma;

  double basAppRat;
  double intCap;

  double customerSize; 

  double capTreshold;
  double capRatTreshold;

  double averageGini;
  double averageIR;

  

  id<NormalDist> capDist;
  id<NormalDist> targCapDist;
  id<NormalDist> riskAvDist;
  id<NormalDist> divFacDist;
  id<NormalDist> marginDist;
  id<NormalDist> costIncDist;
  id<NormalDist> costRatDist;
  id<NormalDist> intRatDist;
  id<NormalDist> memStrengthDist;
  id<NormalDist> expoDist;
  id<NormalDist> ginDist;

  id <List> bankList; // list with numBidders elements
  int time;

  int numSTA;
  int numFIRB;  
}

+createBegin: (id) aZone;
-createEnd;

-buildObjects;
-(id) getBankList;
-(id<Grid2d>)getWorld;

-(int) getTime;
-step;

-updateBankParameters;
-updateBankList;

-reportBankVars;
-(int)getNumBanks;

-updateAverages;
-(double) getAverageGini;
-(double) getAverageIR;
-(double) getPropSTA;

-updateCustPortfolio;



@end


